<?php
/*****************************\
 * PREF Functions
\*****************************/

function loadPreferences()
{
 $prefs = file('ipfmla.conf');
 $GLOBALS['ipfm']=trim($prefs[0]);
 $GLOBALS['IPFMLA_LOGS']=trim($prefs[0]);
 $GLOBALS['speedDown']=trim($prefs[1]);
 $GLOBALS['speedUp']=trim($prefs[2]);
 $GLOBALS['IPFMLA_ROOT']=trim($prefs[3]);
 $GLOBALS['IPFM_ROOT']=trim($prefs[4]);

 if(substr($GLOBALS['IPFMLA_LOGS'],strlen($GLOBALS['IPFMLA_LOGS'])-1,1)=='/')
 {$GLOBALS['IPFMLA_LOGS']=substr($GLOBALS['IPFMLA_LOGS'],0,strlen($GLOBALS['IPFMLA_LOGS'])-1);}

 if(substr($GLOBALS['IPFMLA_ROOT'],strlen($GLOBALS['IPFMLA_ROOT'])-1,1)=='/')
 {$GLOBALS['IPFMLA_ROOT']=substr($GLOBALS['IPFMLA_ROOT'],0,strlen($GLOBALS['IPFMLA_ROOT'])-1);}

 if(substr($GLOBALS['IPFM_ROOT'],strlen($GLOBALS['IPFM_ROOT'])-1,1)=='/')
 {$GLOBALS['IPFM_ROOT']=substr($GLOBALS['IPFM_ROOT'],0,strlen($GLOBALS['IPFM_ROOT'])-1);}

 if(substr($GLOBALS['ipfm'],strlen($GLOBALS['ipfm'])-1,1)=='/')
 {$GLOBALS['ipfm']=substr($GLOBALS['ipfm'],0,strlen($GLOBALS['IPFM_ROOT'])-1);}
}

function savePreferences()
{
 $file=fopen('ipfmla.conf','w');
 fwrite ($file,$GLOBALS['ipfm']."\n");
 fwrite ($file,$GLOBALS['speedDown']."\n");
 fwrite ($file,$GLOBALS['speedUp']."\n");
 fwrite ($file,$GLOBALS['IPFMLA_ROOT']."\n");
 fwrite ($file,$GLOBALS['IPFM_ROOT']."\n");
 fclose ($file);
}

/*****************************\
 * CONFIG Functions
\*****************************/

function loadConfigs()
{
 $configFile = file("ipfmla.db");
 $configs = array();
 foreach($configFile as $line)
 {
  if(trim($line)!='')
  {
   $pieces=explode('|',trim($line));
   $myLine = array(
                   "id"=>$pieces[0],
                   "name"=>$pieces[1],
                   "iface"=>$pieces[2],
                   "network"=>$pieces[3],
                   "without"=>$pieces[4],
                   "with"=>$pieces[5],
                   "auto"=>$pieces[6]
                  );
   $configs[$pieces[0]]=$myLine;
   //array_push($configs,$myLine);
  }
 }
 return $configs;
}

function saveConfig($config)
{
 $file=fopen("ipfmla.db",'w');
 foreach($config as $confi) 
 {
  $st = $confi['id'].'|'.
        $confi['name'].'|'.
        $confi['iface'].'|'.
        $confi['network'].'|'.
        $confi['without'].'|'.
        $confi['with'].'|'.
        $confi['auto'];
  fwrite ($file,$st."\n");
 }
 fclose ($file);

 $file=fopen('/etc/rc.d/rc.ipfm','w');
 foreach($config as $confi) 
 {
  if($confi['auto']=='1')
  {
   fwrite($file,"echo \"Starting IPFM daemon for configuration \\\"".$confi['name']."\\\"\"\n");
   fwrite($file,$GLOBALS['IPFM_ROOT']."/ipfm -c ".$GLOBALS['IPFMLA_ROOT']."/Ipfm/ipfm.conf.".$confi['id']." -n &\n");
   fwrite($file,"\n");
  }
 }
 fclose ($file);
}

/*****************************\
 * LOG Functions
\*****************************/

function getHostsFromFiles($ipfm,$date,$files)
{
 $hosts = array();
 foreach($files as $file)
 {
  $content = file($ipfm.$date.'/'.$file);
  $minutes = explode('_',$file);
  $min = $minutes[0]*60+$minutes[1];
  foreach($content as $con) 
  {
   if(strpos($con,'# ')===false)
   {
    while(!(strpos($con,'  ')===false))
    {
     $con=str_replace('  ',' ',$con);
    }
    $pieces = explode(' ',$con);
    $hosts[$pieces[0]]='1';
   }
  } 
/*  for($i=2;$i<count($content)-1;$i++)
  {
   while(!(strpos($content[$i],'  ')===false))
   {
    $content[$i]=str_replace('  ',' ',$content[$i]);
   }
   $pieces = explode(' ',$content[$i]);
   $hosts[$pieces[0]]='1';
  } */
 }
 return $hosts;
}


function getFilesForDay($ipfm,$date)
{
  $statsFiles = array();
  if ($handle = opendir($ipfm.$date))
  {
    $count=0;
    /* This is the correct way to loop over the directory. */
    while (false !== ($file = readdir($handle)))
    {
     if($file!='.'&&$file!='..')
     {
      array_push($statsFiles ,$file);
     }
    }
    closedir($handle);
    sort($statsFiles);
  }
  return $statsFiles;
}

function getDaysFromDir($ipfm)
{
  $days = array();
  if ($handle = opendir($ipfm))
  {
    $count=0;
    while (false !== ($file = readdir($handle)))
    {
     // is_dir doesn't work :-(
     if($file!='.'&&$file!='..')
     {
      array_push($days,$file);
     }
    }
    closedir($handle);
  }
  rsort($days);
  return $days;
}

function niceSize($in)
{
 if($in>1024*1024*1024*1024) {$res=roundUp($in/(1024*1024*1024*1024)).' TB';}
 else if($in>1024*1024*1024) {$res=roundUp($in/(1024*1024*1024)).' GB';}
 else if($in>1024*1024) {$res=roundUp($in/(1024*1024)).' MB';}
 else if($in>1024) {$res=roundUp($in/1024).' KB';}
 else $res=$in.' B';
 return $res;
}

function roundUp($who)
{
 if($who>100) 
 {
  $who=round($who,0);
 }
 else
 {
  if($who>10)
  {
   $who=round($who,1);
  }
  else
  {
   $who=round($who,2);
  }
 }
 return $who;
}

function niceSizeInt($in)
{
 if($in>1024*1024*1024*1024) {$res=round($in/(1024*1024*1024*1024));}
 else if($in>1024*1024*1024) {$res=round($in/(1024*1024*1024));}
 else if($in>1024*1024) {$res=round($in/(1024*1024));}
 else if($in>1024) {$res=round($in/1024);}
 else $res=$in;
 return $res;
}

?>
